package xvdoc

import (
	"fmt"
	"io/ioutil"
	"log"
	"testing"
)

func TestXVDoc(t *testing.T) {
	if src, err := ioutil.ReadFile("z_source.json"); err == nil {
		if docs, err := FromJSON(src); err == nil {
			log.Println("!!!!!!!", len(docs), docs)
			log.Println("=============================")
			if exp, err := Export("xlsx", docs); err == nil {
				ioutil.WriteFile("tmp.xlsx", exp, 0660)
			} else {
				log.Println(err)
			}

		} else {
			t.Error(err)
		}
	} else {
		t.Error(err)
	}
}

func TestXLSXImport(t *testing.T) {
	sheets, err := ImportXLSXFromFile("tmp.xlsx")
	fmt.Println(sheets, "|", err)
}

func TestXLSXImportToJSON(t *testing.T) {
	src, err := ImportXLSXToJSONFromFile("tmp.xlsx")
	fmt.Println(string(src), "|", err)
}
